﻿"""
"""

import viz
import vizact
import vizinfo
import vizinput

#main window setup
viz.setMultiSample(4)
viz.fov(60)
viz.go(viz.FULLSCREEN)
viz.ipd(0.06)

#Grab the main view. 
view = viz.MainView

# Setup directional light
viz.MainView.getHeadLight().disable()
sky_light = viz.addDirectionalLight(euler=(0,20,0))
sky_light.color(viz.WHITE)
sky_light.ambient([0.8]*3)
viz.setOption('viz.lightModel.ambient',[0]*3)

#Add environment
#viz.addChild('gallery.osgb')
piazza =viz.addChild('piazza.osgb')
viz.addChild('piazza_animations.osgb')

# Swap out sky with animated sky dome
piazza.getChild('pz_skydome').remove()
day = viz.add('sky_day.osgb')

# Loop fountain sound
piazza.playsound('fountain.wav',viz.LOOP,node='fountain-sound')

#Turn collision ON to avoid passing through walls
viz.MainView.collision( viz.ON )

#FSM-9 head tracking
hillcrest=viz.add('HillCrestFSM9.dle')
fsm9=hillcrest.addSensor()
trackerLink=viz.link(fsm9,viz.MainView)
trackerLink.swapEuler([3,2,1])
#Reset tracker when 'r' key is pressed
vizact.onkeydown('r',trackerLink.reset,viz.RESET_ORI_WORLD)

import vizcam
viz.cam.setHandler(vizcam.KeyboardCamera(forward='w',backward='s', left='a',right='d',turnRight='e',turnLeft='q'))
viz.mouse.setVisible(viz.OFF)
def mousemove(e):
	euler = view.get(viz.BODY_EULER)
	euler[0] += e.dx*0.1
	euler[1] += -e.dy*0.1
	euler[1] = viz.clamp(euler[1],-90.0,90.0)
	view.setEuler(euler[0],0,mask=viz.BODY_ORI);

viz.callback(viz.MOUSE_MOVE_EVENT,mousemove)


